/**
    KeyWriter.c - Writes a 128 AES encryption key to a SmartDongle

    MicroWorks, Inc.
    2808 North Cole Road
    Boise, ID 83704

    www.smartdongle.com


    ***** BEGIN LICENSE BLOCK *****

    Version: MPL 1.1/GPL 2.0/LGPL 2.1

    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/

    Software distributed under the License is distributed on an "AS IS" basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
    for the specific language governing rights and limitations under the
    License.

    The Original Code is MicroWorks, Inc. code.

    The Initial Developer of the Original Code is MicroWorks, Inc. Portions
    created by MicroWorks, Inc. are Copyright (C) 2010
    MicroWorks, Inc. All Rights Reserved.

    Contributor(s):

    Alternatively, the contents of this file may be used under the terms of
    either the GNU General Public License Version 2 or later (the "GPL"), or
    the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
    in which case the provisions of the GPL or the LGPL are applicable instead
    of those above. If you wish to allow use of your version of this file only
    under the terms of either the GPL or the LGPL, and not to allow others to
    use your version of this file under the terms of the MPL, indicate your
    decision by deleting the provisions above and replace them with the notice
    and other provisions required by the GPL or the LGPL. If you do not delete
    the provisions above, a recipient may use your version of this file under
    the terms of any one of the MPL, the GPL or the LGPL.

    ***** END LICENSE BLOCK *****
*/
#include <stdio.h>
#include "smartdongle.h"
#include "sd_eeprom.h"
#include "sd_uskerr.h"

/* Some random 128 bit AES key */
#define AES_KEY "7obdgEn2'TH>]SE|" 

int main(int argc, char* argv[])
{
	/* Your SmartDongle keys */
	unsigned __int64 P1 = 0xec6cc589aefd1e75;
	unsigned __int64 P2 = 0xfcec0a6a82747b3f;

	/* address to write the key at */
	unsigned short address = 0;

    unsigned char key[] = AES_KEY;
    char errorString[QTS_ERROR_STRING_LENGTH_MAX];
    int error = USK_OK;

	 /*
        Turn SmartDongle Red LED on to indicate write in progress.
    */
    SmartDongleLedRed();

    /*
        Write a user string to SmartDongle.
    */
    error = SmartDongleWrite(P1, P2, address, key, strlen((char*)key) + 1);
    if (error) {
        SmartDongleGetErrorString(errorString, error);
        printf("%s\n", errorString);
    } else {
        printf("Success: Wrote AES encryption key application data to SmartDongle\n");
        SmartDongleLedGreen();
    }

    printf("\nPress any key to exit\n");
    getchar();

	return 0;
}

