/*
    example3b.c:  Example that read and decrypts a user string from
                  a SmartDongle as written in example3a.c


    www.smartdongle.com

    MicroWorks, Inc.
    2808 North Cole Road
    Boise, ID 83704
*/

#include <stdio.h>
#include <malloc.h>
#include "smartdongle.h"
#include "sd_eeprom.h"
#include "sd_uskerr.h"
#include "aes.h"
#include <conio.h>


/*
    For demonstration only, use your own unique AES key and secrets for
    your application.
*/

/* Your secret */
//#define YOUR_SECRET "This is the secret written to SmartDongle, it can be passwords, serial numbers, program parameters, etc"
#define YOUR_SECRET "1EC6CC589AEFD1E75FCEC0A6A82747B3FEC6CC589AEFD1E75FCEC0A6A82747B3FEC6CC589AEFD1E75FCEC0A6A82747B3FEC6CC589AEFD1E75FCEC0A6A82747B3F"

/* Some random 128 bit AES key */
//#define AES_KEY "7obdgEn2'TH>]SE|" 
#define AES_KEY "RyAn'SEncrYptioN"  

/* 128 bit block encryption */
#define AES_BLOCKSIZE 128    

int main(int argc, char* argv[])
{
    unsigned __int64 P1, P2;
    unsigned char key[] = AES_KEY;
    unsigned char your_secret[] = YOUR_SECRET;
    char errorString[QTS_ERROR_STRING_LENGTH_MAX];
    int size = AES_BLOCKSIZE;
    int error = USK_OK;
	FILE fp;
    /*
      The number of blocks your secret requires and address in SmartDongle
      memory was obtained in example3b.c
    */
    unsigned char cipherText[9 * (AES_BLOCKSIZE / 8)];
    const unsigned cipherTextBlocks = 9;
    const unsigned short cipherTextAddress = 0;


    /*
        Your SmartDongle key go here.
    */
#ifdef _GNUC_ /* For GNU  */
    P1 = 0xec6cc589aefd1e75ULL;
    P2 = 0xfcec0a6a82747b3fULL;
#else
    P1 = 0xec6cc589aefd1e75;
    P2 = 0xfcec0a6a82747b3f;
#endif


    /*
       Read encrypted secret back from SmartDongle's user memory and decrypt.
    */
    if (!error) {
        error = SmartDongleRead(
            P1,
            P2,
            cipherTextAddress,
            cipherText,
            cipherTextBlocks * (AES_BLOCKSIZE / 8));
        if (error)
        {
            SmartDongleGetErrorString(errorString, error);
            printf("%s\n", errorString);
        }
    }


    /*
        Decrypt ciphertext block read from SmartDongle and compare to
        the expected user data.
    */
    if (!error) {

        JIKpbm3(cipherText, cipherTextBlocks, key, AES_BLOCKSIZE);

        if(strcmp(cipherText, your_secret) == 0) {
            printf("Success: Your secret has been verified\n");
        } else {
            printf("Failure: decoded data does not match your secret\n");
        }
    }


    printf("\nPress any key to exit\n");
    getch();


    return 0;
}
