/*
   sd_cp2.h for SmartDongle API version 3.2


   www.smartdongle.com

   MicroWorks, Inc.
   2808 North Cole Road
   Boise, ID 83704
*/

#ifndef _DEFINE_E19FF147_CA2C_4063_8A2D_B1444032F2FF
#define _DEFINE_E19FF147_CA2C_4063_8A2D_B1444032F2FF

#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

/*
   Memory index for the EEPROM USB config file
*/
#define CP2_ID_VENDOR_MSB                0x19
#define CP2_ID_VENDOR_LSB                0x18
#define CP2_ID_PRODUCT_MSB               0x1B
#define CP2_ID_PRODUCT_LSB               0x1A
#define CP2_DEV_VERSION_MSB              0x1D
#define CP2_DEV_VERSION_LSB              0x1C
#define CP2_I_MANUFACTURER               0x1E
#define CP2_I_PRODUCT                    0x1F
#define CP2_I_SERIALNUM                  0x20

/*
   Indexes for string pointers
*/
#define CP2_LANGUAGE_ID_STRING_ADDR          0x04
#define CP2_MANUFACTURER_STRING_ADDR         0x05
#define CP2_PRODUCT_STRING_ADDR              0x06
#define CP2_SERNUM_STRING_ADDR               0x07

#define CP2_LANGUAGE_ID_STRING_ADDR_pre141   0x08
#define CP2_MANUFACTURER_STRING_ADDR_pre141  0x09
#define CP2_PRODUCT_STRING_ADDR_pre141       0x0A
#define CP2_SERNUM_STRING_ADDR_pre141        0x0D

/*
   Expected size of ID strings and limit to descriptor string length
*/
#define CP2_ID_STR_LENGTH                5
#define CP2_VER_STR_LENGTH               6
#define CP2_SERIALNUM_PREFIX_LENGTH      4
#define CP2_SERIALNUM_LENGTH             12
#define CP2_SER_NUMB_STRING_LENGTH       2 + (CP2_SERIALNUM_LENGTH * 2)

/*
   The EEPROM space reserved for USB descriptors is 256 bytes.
*/
#define CP2_IMAGE_SIZE                   256

/*
   Firmware 1.41 and above will prefetch EPROM pages.
*/
#define CP2_PAGE_PREFETCH_ENABLED        8

#if defined(__cplusplus) || defined(__cplusplus__)
}
#endif

#endif /* _DEFINE_E19FF147_CA2C_4063_8A2D_B1444032F2FF */
